using System.Runtime.InteropServices;
using System;
using System.Drawing;
using System.Windows.Forms;
using System.Diagnostics;

namespace ScreenWaterMark
{
    public partial class Watermark : Form
    {
        [DllImport("user32.dll")]
        public static extern IntPtr GetForegroundWindow();

        [DllImport("user32.dll", SetLastError = true)]
        public static extern uint GetWindowThreadProcessId(IntPtr hWnd, out uint lpdwProcessId);

        [DllImport("user32.dll")]
        public static extern uint SetWindowDisplayAffinity(IntPtr hwnd, uint dwAffinity);


        bool bShow = true;
        string userName = "";
        public Watermark()
        {
            InitializeComponent();
            this.Opacity = .1;
            this.TopMost = true;
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
            this.WindowState = FormWindowState.Maximized;
            this.Paint += Watermark_Paint;
            userName = System.Security.Principal.WindowsIdentity.GetCurrent().Name;
            if (userName.Contains("\\") == true)
            {
                userName = userName.Substring( userName.IndexOf("\\") + 1);
            }

            const uint WDA_NONE = 0;
            const uint WDA_MONITOR = 1;
            SetWindowDisplayAffinity(this.Handle, WDA_MONITOR);
        }

        // this makes the form ignore all clicks, so it is "passthrough"
        protected override System.Windows.Forms.CreateParams CreateParams
        {
            get
            {
                CreateParams cp = base.CreateParams;
                cp.ExStyle |= 0x80000 /* WS_EX_LAYERED */| 0x20 /* WS_EX_TRANSPARENT */;
                cp.ExStyle |= 0x00000080;

                return cp;
            }
        }

        private void Watermark_Paint(object sender, PaintEventArgs e)
        {
            
            
            string finalString = userName + "\r\n " + DateTime.Now.ToString("dd-MM-yyyy HH:mm");
            if (userName != "" && bShow == true)
            {   
                // play with this drawing code to change your "watermark"
                SizeF szF = e.Graphics.MeasureString(userName, this.Font);
                e.Graphics.RotateTransform(-45);
                int max = Math.Max(this.Width, this.Height);
                for (int y = 0; y<=max; y=y+(2*(int)szF.Height))
                {
                    e.Graphics.DrawString(finalString, this.Font, Brushes.Black, 0, y);
                }

                //e.Graphics.DrawString(finalString, this.Font, Brushes.Black, -20, this.Height - 20); ;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                IntPtr hWnd = GetForegroundWindow();
                uint procId = 0;
                GetWindowThreadProcessId(hWnd, out procId);
                var proc = Process.GetProcessById((int)procId);
                //Console.WriteLine(proc.MainModule);
                if (proc.MainModule.ModuleName.StartsWith("ScreenWaterMark") == true || proc.MainModule.ModuleName.StartsWith("devenv", StringComparison.OrdinalIgnoreCase) == true)
                {
                    if (bShow == true)
                    {
                        bShow = false;
                        this.Refresh();
                    }
                }
                else
                {
                    if (bShow == false)
                    {
                        bShow = true;
                        this.Refresh();
                    }
                }
                
            }
            catch (Exception)
            {
            }
        }
    }
}